//////////////////////////////////////////////////////////////////////////////
// 8to4bit.cpp                                                              //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <stdio.h>

//////////////////////////////////////////////////////////////////////////////
// main                                                                     //
//////////////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[])
{
	if (argc<3)
	{
		printf("%s [input.wav] [output.raw]\n", argv[0]);
		return -1;
	}

	FILE *fi = fopen(argv[1], "rb");
	if (!fi) { printf("Input error!\n"); return -1; }
	FILE *fo = fopen(argv[2], "wb");
	if (!fo) { printf("Output error!\n"); return -1; }

	fseek(fi, 40, SEEK_SET);
	unsigned long size;
	fread(&size, 4, 1, fi);
	while (size > 0)
	{
		char buf[32];
		int blocksize = (size>=32 ? 32 : size);
		fread(&buf, 1, blocksize, fi);
		for (; blocksize<32; ) buf[blocksize++] = 0; // fill with zero's
		for (int n=0; n<16; n++)
		{
			char b = buf[2*n]>>4 | buf[2*n+1]>>4<<4;
			fwrite(&b, 1, 1, fo);
		}
		size -= 32;
	}

	fclose(fi);
	fclose(fo);
	return 0;
}
