// binary to ASM converter

#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
	FILE *fi;
	if (argc >= 2) {
		fi = fopen(argv[1], "rb");
	} else {
		printf("%s <input.bin> [<output.s>] [<identifier>]\n", argv[0]);
		return 1;
	}
	if (!fi) { printf("Input error!\n"); return 1; }

	FILE *fo;
	if (argc >= 3) {
		fo = fopen(argv[2], "wt");
	} else {
		strcpy(strrchr(argv[1], '.'), ".s");
		fo = fopen(argv[1], "wt");
	}
	if (!fo) { printf("Output error!\n"); return 1; }

	if (argc >= 4) {
		fprintf(fo, "_%s::\n", argv[3]);
	} else {
		char *s = strrchr(argv[1], '\\');
		if (!s) s = argv[1]; else s++;
		strcpy(strrchr(s, '.'), "");
		fprintf(fo, "_%s::\n", strlwr(s));
	}

	while (!feof(fi))
	{
		fprintf(fo, "\t.db\t");
		for (int i=0; i<16; i++)
		{
			unsigned char c;
			if (fread(&c, 1, 1, fi) == 0) break;
			if ((i < 15) && !feof(fi))
				fprintf(fo, "0x%02X,", c);
			else
				fprintf(fo, "0x%02X", c);
		}
		fprintf(fo, "\n");
	}

	fclose(fi);
	fclose(fo);
	return 0;
}