// convert RGBASM MAP-file to INClude file

#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
  if (argc < 3) { printf("Please specify input [.MAP] and output [.ASM].\n"); return 1; }
  FILE *fi = fopen(argv[1], "rt");
  if (!fi) { printf("Input error!\n"); return 1; }
  FILE *fo = fopen(argv[2], "wt");
  if (!fo) { printf("Output error!\n"); return 1; }
  fprintf(fo, ";----------------------------------------------------------------------------;\n");
  fprintf(fo, "; LINK - ROM calls generated by MAP2INC                                      ;\n");
  fprintf(fo, ";----------------------------------------------------------------------------;\n\n");

  while (!feof(fi)) {
	char s[256];
	fgets(s, 256, fi); *strstr(s, "\n") = 0;
	if (strncmp(s, "           ", 11) == 0) {
	  s[16] = 0;
	  if (strcmp(&s[19], "Main") != 0) {
		*strstr(&s[19], ".") = '_';     // '.' -> '_'
		fprintf(fo, "%s equ %s\n", &s[19], &s[11]);
	  }
	}
  }

  fprintf(fo, "\n;----------------------------------------------------------------------------;\n");
  fclose(fi);
  fclose(fo);
  return 0;
}
