//////////////////////////////////////////////////////////////////////////////
// pal2bin.cpp                                                              //
//////////////////////////////////////////////////////////////////////////////
// JASC palette (256 colors) to binary converter
// bits:
//	12 NGPC
//	15 GBC/GBA
//	24 R,G,B
//	32 R,G,B,0

//////////////////////////////////////////////////////////////////////////////
// Includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//////////////////////////////////////////////////////////////////////////////
// main                                                                     //
//////////////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[])
{
	if (argc < 3) { printf("Syntax: %s <input.pal> <output.bin> [12|15|<24>|32]\n", argv[0]); return -1; }
	FILE *fi = fopen(argv[1], "rt");
	if (!fi) { printf("Error opening input file!\n"); return -1; }
	FILE *fo = fopen(argv[2], "wb");
	if (!fo) { printf("Error opening input file!\n"); return -1; }
	int bits = 24;
	if (argv[3]) bits = atoi(argv[3]);

	fscanf(fi, "JASC-PAL\n");
	fscanf(fi, "0100\n");
	fscanf(fi, "256\n");
	for (int i=0; i<256; i++)
	{
		int r,g,b;
		if (fscanf(fi, "%d %d %d\n", &r,&g,&b) != 3) { printf("Formatting error!\n"); return -1; };
		int rgb;
		switch (bits)
		{
			case 12:
				rgb = b>>4<<8 | g>>4<<4 | r>>4<<0;
				fputc(rgb>>0, fo);
				fputc(rgb>>8, fo);
				break;

			case 15:
				rgb = b>>3<<10 | g>>3<<5 | r>>3<<0;
				fputc(rgb>>0, fo);
				fputc(rgb>>8, fo);
				break;

			case 24:
				fputc(r, fo);
				fputc(g, fo);
				fputc(b, fo);
				break;
			
			case 32:
				fputc(r, fo);
				fputc(g, fo);
				fputc(b, fo);
				fputc(0, fo);
				break;
				
			default:
				printf("Invalid bit depth!\n");
				return -1;
		}
	}

	fclose(fi);
	fclose(fo);
	return 0;
}
